Attribute VB_Name = "modPivot"
Option Explicit

Sub CreatePivotTables()

' ------------------------------------------------------------------------------------------
'  : ŷ ̺ ϴ ǹ̺ մϴ.
'   : 2005 / 9 / 12
' ̸ : 286pc@korea.com / haruhana@gmail.com
' ------------------------------------------------------------------------------------------

    Dim pvSales As PivotTable
    Dim rSource As Range

    With Worksheets("⳻ǥ")

        On Error Resume Next
        
            .PivotTables(1).TableRange2.Delete
        
        On Error GoTo 0
    
        Set rSource = Range("̺").CurrentRegion
        
        ActiveWorkbook.PivotCaches.Add(xlDatabase, rSource).CreatePivotTable .Range("A8")
            
        With .PivotTables(1)
            
            .AddDataField .PivotFields(""), "Ǹž"
            .PivotFields("Ǹž").NumberFormat = "#,##0"
            
            .AddFields RowFields:="ֹ"
            .PivotFields("ֹ").DataRange.Cells(1).Group Periods:=Array(False, False, False, True, False, True, False)
            
            .AddFields ColumnFields:="⵵"
            .AddFields RowFields:="", AddtoTable:=True
            
            .TableRange1.Font.Name = "Arial"
            .TableRange2.ColumnWidth = "12"
            .HasAutoFormat = False
            .DisplayErrorString = True
        
        End With
        
    End With
    
    Set rSource = Nothing
    Set pvSales = Nothing

End Sub

Sub ChangePivotTable()

' ------------------------------------------------------------------------------------------
'  :  ǹ̺  ɼǿ ° ̾ƿ մϴ.
'   : 2005 / 9 / 12
' ̸ : 286pc@korea.com / haruhana@gmail.com
' ------------------------------------------------------------------------------------------

    Dim iSelect As Integer, sField As String
    Dim pvSales As PivotTable
    Dim pvFieldUD As PivotField
    
        Set pvSales = ActiveSheet.PivotTables(1)
        iSelect = Range("ɼǼ")

        sField = WorksheetFunction.Choose(iSelect, "б", "", "", "з", "")
        
        Application.ScreenUpdating = False

            With pvSales
                .AddFields RowFields:=sField
                .AddFields ColumnFields:="⵵", AddtoTable:=True
                
                On Error Resume Next
                    
                    Set pvFieldUD = .PivotFields("")
                    
                    If Err = 0 Then pvFieldUD.Orientation = xlHidden
                    If Range("ǥ") = True Then AddPercent
                
                On Error GoTo 0
                
            End With
        
        Application.ScreenUpdating = True
        
    Set pvSales = Nothing

End Sub

Sub AddPercent()

' ------------------------------------------------------------------------------------------
'  : ǹ̺ ʵ念 '' ǥմϴ.
'   : 2005 / 9 / 12
' ̸ : 286pc@korea.com / haruhana@gmail.com
' ------------------------------------------------------------------------------------------

    Dim ynAdd As Boolean
    
    ynAdd = Range("ǥ")
    
    Application.ScreenUpdating = False
    
        On Error Resume Next
            ActiveSheet.PivotTables(1).DataFields("").Orientation = xlHidden
        On Error GoTo 0
        
        If ynAdd = True Then
        
            With ActiveSheet.PivotTables(1)
                .AddDataField .PivotFields(""), ""
                
                With .PivotFields("")
                    .Calculation = xlPercentOf
                    .BaseField = "⵵"
                    .BaseItem = "()"
                    .NumberFormat = "0.00%"
                End With
            
                .DataPivotField.Orientation = xlColumnField
                .DataPivotField.Position = 2
            
            End With
        
        End If

    Application.ScreenUpdating = True
    
End Sub
